<template>
    <div class="content">
        <div class="intro-y flex flex-col sm:flex-row items-center my-8">
            <div class="mr-auto">
                <h2 class="text-lg font-medium mr-auto">
                    Management Category
                </h2>
            </div>
        </div>
        <div class="grid grid-cols-12 gap-6 mt-5">
            <div class="intro-y col-span-12 lg:col-span-6">
                <!-- BEGIN: Form Layout -->
                <div class="intro-x box p-5">
                    <form @submit.prevent="submit">
                        <div>
                            <label for="crud-form-1" class="form-label mt-2">Name</label>
                            <input id="crud-form-1" type="text" class="form-control w-full" placeholder="Input Name"
                                v-model="name">
                        </div>
                        <div>
                            <label for="crud-form-1" class="form-label mt-2">Color Picker</label>
                            <input id="crud-form-1" type="text" class="form-control w-full" placeholder="Pick a color"
                                v-model="colorSelected" readonly>

                            <button type="button" @click="isOpen = !isOpen"
                                class="w-10 h-10 my-2 rounded-full focus:outline-none focus:shadow-outline inline-flex p-2 shadow"
                                :style="colorSelected != '' ? `background: ${colorSelected}; color: white` : `background: #2196F3 ; color: white`">
                                <svg class="w-6 h-6 fill-current" xmlns="http://www.w3.org/2000/svg"
                                    viewBox="0 0 24 24">
                                    <path fill="none"
                                        d="M15.584 10.001L13.998 8.417 5.903 16.512 5.374 18.626 7.488 18.097z" />
                                    <path
                                        d="M4.03,15.758l-1,4c-0.086,0.341,0.015,0.701,0.263,0.949C3.482,20.896,3.738,21,4,21c0.081,0,0.162-0.01,0.242-0.03l4-1 c0.176-0.044,0.337-0.135,0.465-0.263l8.292-8.292l1.294,1.292l1.414-1.414l-1.294-1.292L21,7.414 c0.378-0.378,0.586-0.88,0.586-1.414S21.378,4.964,21,4.586L19.414,3c-0.756-0.756-2.072-0.756-2.828,0l-2.589,2.589l-1.298-1.296 l-1.414,1.414l1.298,1.296l-8.29,8.29C4.165,15.421,4.074,15.582,4.03,15.758z M5.903,16.512l8.095-8.095l1.586,1.584 l-8.096,8.096l-2.114,0.529L5.903,16.512z" />
                                </svg>
                            </button>
                        </div>
                        <div v-show="isOpen" x-transition:enter="transition ease-out duration-100 transform"
                            x-transition:enter-start="opacity-0 scale-95" x-transition:enter-end="opacity-100 scale-100"
                            x-transition:leave="transition ease-in duration-75 transform"
                            x-transition:leave-start="opacity-100 scale-100" x-transition:leave-end="opacity-0 scale-95"
                            class="origin-top-right absolute mt-2 w-40 rounded-md shadow-lg">
                            <div class="rounded-md bg-white shadow-xs px-4 py-3">
                                <div class="flex flex-wrap -mx-2">
                                    <template v-for="(color, index) in colors" :key="index">
                                        <div class="px-2">
                                            <template v-if="colorSelected === color">
                                                <div class="w-8 h-8 inline-flex rounded-full cursor-pointer border-4 border-white"
                                                    :style="`background: ${color}; box-shadow: 0 0 0 2px rgba(0, 0, 0, 0.2);`">
                                                </div>
                                            </template>

                                            <template v-if="colorSelected != color">
                                                <div @click="colorSelected = color"
                                                    @keydown.enter="colorSelected = color" role="checkbox" tabindex="0"
                                                    :aria-checked="colorSelected"
                                                    class="w-8 h-8 inline-flex rounded-full cursor-pointer border-4 border-white focus:outline-none focus:shadow-outline"
                                                    :style="`background: ${color};`"></div>
                                            </template>
                                        </div>
                                    </template>
                                </div>
                            </div>
                        </div>
                        <div class="modal-footer text-right">
                            <a type="button" data-tw-dismiss="modal"
                                class="btn btn-outline-secondary w-20 mr-1" href="/category">Cancel</a>
                            <button type="submit" class="btn btn-primary w-20">{{label}}</button>
                        </div>
                        
                    </form>
                </div>
                
                <!-- END: Form Layout -->
            </div>
        </div>
    </div>
</template>

<script>
    import Toastify from 'toastify-js';

    export default {
        name: 'FormOrganizer',
        data() {
            return {
                code: "",
                name: "",
                edit: false,
                label: "Save",
                fieldEmpty: [],
                error: "",
                id: 0,
                category: null,
                isOpen: false,
                colors: ['#2196F3', '#009688', '#9C27B0', '#FFEB3B', '#afbbc9', '#4CAF50', '#2d3748', '#f56565','#FACC15','#16A34A',
                    '#ed64a6','#38BDF8','#3B82F6'
                ],
                colorSelected: '#2196F3'
            }
        },
        created: function () {
            var splitUrl = this.$route.path.split("/");
            if (splitUrl[1] == "edit-category") {
                this.edit = true
                this.id = splitUrl[2]
                this.label = "Edit"
            }
        },
        methods: {
            async getDetail() {
                this.$axios.get(`/category/${this.id}/detail`, {
                        headers: {
                            "Token": this.$store.state.user.token,
                            "User-ID": this.$store.state.user.user_id
                        }
                    })
                    .then((response) => {
                        const data = response.data.data
                        console.log(data)
                        this.category = data
                        this.name = data.name
                        this.colorSelected = data.color ? data.color : "#2196F3"
                    }).catch(error => {
                        console.log(error);
                    });
            },
            reset() {
                this.name = this.category.name
            },
            submit: function () {
                if (this.name == "") {
                    this.fieldEmpty.push('name')
                }

                if (this.colorSelected == "") {
                    this.fieldEmpty.push('color')
                }

                if (this.fieldEmpty.length > 0) {

                    this.error = this.fieldEmpty.join(" & ")
                    this.error += ` is empty`

                    Toastify({
                        text: `ERROR : ${this.error}`,
                        duration: 3000,
                        newWindow: true,
                        close: true,
                        gravity: "top",
                        position: "right",
                        stopOnFocus: true,
                        className: "toastify-content",
                    }).showToast();

                    this.fieldEmpty = []
                    this.error = ""
                    return
                }
                let body = {
                    name: this.name,
                    color : this.colorSelected
                }
                if (this.edit) {

                    this.$axios.put(`/category/${this.id}/update`, body, {
                        headers: {
                            "Token": this.$store.state.user.token,
                            "User-ID": this.$store.state.user.user_id
                        }
                    }).then(() => {
                        Toastify({
                            text: `Update Organizer Success`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                        this.$router.push({
                            name: 'data-category'
                        })
                    }).catch((error) => {
                        Toastify({
                            text: `ERROR : ${error.response.data.message}`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                    });
                } else {

                    this.$axios.post("/category", body, {
                        headers: {
                            "Token": this.$store.state.user.token,
                            "User-ID": this.$store.state.user.user_id
                        }
                    }).then(() => {
                        Toastify({
                            text: `Create Organizer Success`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();

                        this.$router.push({
                            name: 'data-category'
                        })
                    }).catch((error) => {
                        Toastify({
                            text: `ERROR : ${error.response.data.message}`,
                            duration: 3000,
                            newWindow: true,
                            close: true,
                            gravity: "top",
                            position: "right",
                            stopOnFocus: true,
                            className: "toastify-content",
                        }).showToast();
                    });
                }
            }
        },
        mounted() {
            if (this.edit) {
                this.getDetail()
            }

        }
    }
</script>